# https://docs.odriverobotics.com/v/0.5.4/getting-started.html
# https://docs.odriverobotics.com/v/0.5.4/encoders.html
# https://eu.odriverobotics.com/shop/cui-amt-102
# https://hobbyking.com/en_us/turnigy-sk8-6374-192kv-sensored-brushless-motor-14p.html

# pos vinkel er med klokka

odrv0.vbus_voltage

############################################################# HELP
dump_errors(odrv0)
odrv0.reboot()
odrv0.axis0.controller.input_pos # lese av pos
odrv0.axis0.encoder.config.offset = 0 # i manuelt satt pos, resetter off
odrv0.axis0.requested_state = AXIS_STATE_IDLE
exec(open('r2.py').read())

############################################################# INI 0 liten motor 8192
odrv0.axis0.motor.config.current_lim = 50 # Overordnet
odrv0.axis0.controller.config.vel_limit = 50 # Overordnet
odrv0.axis0.motor.config.torque_constant = 8.27/192 # 8.27 / 90 (8.27/KT)
odrv0.axis0.motor.config.motor_type = MOTOR_TYPE_HIGH_CURRENT
odrv0.axis0.encoder.config.cpr = 8192
odrv0.axis0.motor.config.calibration_current = 10 # under kalibrering
odrv0.axis0.encoder.config.use_index = True
odrv0.config.brake_resistance = 2
odrv0.axis0.motor.config.pole_pairs = 7 #20
odrv0.config.dc_max_negative_current = -1

odrv0.axis0.trap_traj.config.accel_limit = 10 # 45 # For trapes
odrv0.axis0.trap_traj.config.vel_limit = 25 # 35 # For trapes 
odrv0.axis0.trap_traj.config.decel_limit = 10 # 45 # For trapes
odrv0.axis0.controller.config.pos_gain = 10 # 180 # strammhet
odrv0.axis0.controller.config.vel_gain = 0.5 # turn/s
odrv0.axis0.controller.config.vel_integrator_gain = 0.1 # accelerasjon?
odrv0.axis0.controller.config.input_mode = INPUT_MODE_TRAP_TRAJ # God og lur å ha

odrv0.axis0.requested_state = AXIS_STATE_FULL_CALIBRATION_SEQUENCE
odrv0.save_configuration() # Ikke bry seg om feilmelding

############################################################# INI 1 liten motor 20480
odrv0.axis1.motor.config.current_lim = 50 # Overordnet
odrv0.axis1.controller.config.vel_limit = 50 # Overordnet
odrv0.axis1.motor.config.torque_constant = 8.27/192 # 8.27 / 90 (8.27/KT)
odrv0.axis1.motor.config.motor_type = MOTOR_TYPE_HIGH_CURRENT
odrv0.axis1.encoder.config.cpr = 20480
odrv0.axis1.motor.config.calibration_current = 10 # under kalibrering
odrv0.axis1.encoder.config.use_index = True
odrv0.config.brake_resistance = 2
odrv0.axis1.motor.config.pole_pairs = 7 #20
odrv0.config.dc_max_negative_current = -1

odrv0.axis1.trap_traj.config.accel_limit = 10 # 45 # For trapes
odrv0.axis1.trap_traj.config.vel_limit = 25 # 35 # For trapes 
odrv0.axis1.trap_traj.config.decel_limit = 10 # 45 # For trapes
odrv0.axis1.controller.config.pos_gain = 10 # 180 # strammhet
odrv0.axis1.controller.config.vel_gain = 0.5 # turn/s
odrv0.axis1.controller.config.vel_integrator_gain = 0.1 # accelerasjon?
odrv0.axis1.controller.config.input_mode = INPUT_MODE_TRAP_TRAJ # God og lur å ha

odrv0.axis1.requested_state = AXIS_STATE_FULL_CALIBRATION_SEQUENCE
odrv1.save_configuration() # Ikke bry seg om feilmelding

############################################################# INI 1 stor motor
odrv0.axis1.motor.config.current_lim = 50 # Overordnet
odrv0.axis1.controller.config.vel_limit = 50 # Overordnet
odrv0.axis1.motor.config.torque_constant =  8.27 / 90 
odrv0.axis1.motor.config.motor_type = MOTOR_TYPE_HIGH_CURRENT
odrv0.axis1.encoder.config.cpr = 8192
odrv0.axis1.motor.config.calibration_current = 10 # under kalibrering
odrv0.axis1.encoder.config.use_index = True
odrv0.config.brake_resistance = 2
odrv0.axis1.motor.config.pole_pairs = 20
odrv0.config.dc_max_negative_current = -1

odrv0.axis1.trap_traj.config.accel_limit = 45 # For trapes
odrv0.axis1.trap_traj.config.vel_limit = 35 # For trapes 
odrv0.axis1.trap_traj.config.decel_limit = 45 # For trapes
odrv0.axis1.controller.config.pos_gain = 180 # strammhet
odrv0.axis1.controller.config.vel_gain = 0.5 # turn/s
odrv0.axis1.controller.config.vel_integrator_gain = 0.1 # accelerasjon?
odrv0.axis1.controller.config.input_mode = INPUT_MODE_TRAP_TRAJ # God og lur å ha

odrv0.axis1.requested_state = AXIS_STATE_FULL_CALIBRATION_SEQUENCE
odrv0.save_configuration() # Ikke bry seg om feilmelding

############################################################# SETTE INDEX PULSE 0
odrv0.axis0.encoder.config.use_index = True
odrv0.axis0.requested_state = AXIS_STATE_FULL_CALIBRATION_SEQUENCE
odrv0.axis0.requested_state = AXIS_STATE_ENCODER_INDEX_SEARCH
odrv0.axis0.requested_state = AXIS_STATE_ENCODER_OFFSET_CALIBRATION
odrv0.axis0.error # 0
odrv0.axis0.encoder.config.phase_offset # et heltall
odrv0.axis0.encoder.config.direction # 1 eller -1
odrv0.axis0.encoder.config.pre_calibrated = True
odrv0.axis0.config.startup_encoder_index_search = False # hvis søk under startup, ellers kjøre AXIS_STATE_ENCODER_INDEX_SEARCH hver gang
odrv0.axis0.motor.config.pre_calibrated = True
odrv0.save_configuration() # Ikke bry seg om feilmelding

############################################################# SETTE INDEX PULSE 1
odrv0.axis1.encoder.config.use_index = True
odrv0.axis1.requested_state = AXIS_STATE_FULL_CALIBRATION_SEQUENCE
odrv0.axis1.requested_state = AXIS_STATE_ENCODER_INDEX_SEARCH
odrv0.axis1.requested_state = AXIS_STATE_ENCODER_OFFSET_CALIBRATION
odrv0.axis1.error # 0
odrv0.axis1.encoder.config.phase_offset # et heltall
odrv0.axis1.encoder.config.direction # 1 eller -1
odrv0.axis1.encoder.config.pre_calibrated = True
odrv0.axis1.config.startup_encoder_index_search = False # hvis søk under startup, ellers kjøre AXIS_STATE_ENCODER_INDEX_SEARCH hver gang
odrv0.axis1.motor.config.pre_calibrated = True
odrv0.save_configuration() # Ikke bry seg om feilmelding

############################################################# STARTUP 0

odrv0.axis0.requested_state = AXIS_STATE_ENCODER_INDEX_SEARCH
# odrv0.axis0.requested_state = AXIS_STATE_FULL_CALIBRATION_SEQUENCE

odrv0.axis0.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
odrv0.axis0.requested_state = AXIS_STATE_IDLE

############################################################# STARTUP 1

odrv0.axis1.requested_state = AXIS_STATE_ENCODER_INDEX_SEARCH
# odrv0.axis1.requested_state = AXIS_STATE_FULL_CALIBRATION_SEQUENCE

odrv0.axis1.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
odrv0.axis1.requested_state = AXIS_STATE_IDLE

#############################################################
#############################################################
#############################################################

from datetime import datetime
import time
import math 

dT = 2000 # samplings intervall us, 500Hz
f = 0.7   # Hz for sinus eksemplet 

periodNoNow = 0
periodNoOld = 0 
odrv0.axis0.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
for sampNr in range(500*20): # 10sec, 5000sampler
    while periodNoNow == periodNoOld:
        tim = datetime.now()
        t = 60*1000000*tim.minute + 1000000*tim.second + tim.microsecond # usec
        periodNoNow = int(t / dT)   
    periodNoOld = periodNoNow 
    odrv0.axis0.controller.input_pos = 0.1*math.sin(2*math.pi*f*t/1000000)  + 0.07*math.sin(4*math.pi*f*t/1000000)
odrv0.axis0.requested_state = AXIS_STATE_IDLE

periodNoNow = 0
periodNoOld = 0 
odrv0.axis1.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
for sampNr in range(500*20): # 10sec, 5000sampler
    while periodNoNow == periodNoOld:
        tim = datetime.now()
        t = 60*1000000*tim.minute + 1000000*tim.second + tim.microsecond # usec
        periodNoNow = int(t / dT)   
    periodNoOld = periodNoNow 
    odrv0.axis1.controller.input_pos = 0.1*math.sin(2*math.pi*f*t/1000000)  + 0.07*math.sin(4*math.pi*f*t/1000000)
odrv0.axis1.requested_state = AXIS_STATE_IDLE

periodNoNow = 0
periodNoOld = 0 
odrv0.axis0.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
odrv0.axis1.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
for sampNr in range(500*20): # 10sec, 5000sampler
    while periodNoNow == periodNoOld:
        tim = datetime.now()
        t = 60*1000000*tim.minute + 1000000*tim.second + tim.microsecond # usec
        periodNoNow = int(t / dT)   
    periodNoOld = periodNoNow 
    odrv0.axis0.controller.input_pos = 0.1*math.sin(2*math.pi*f*t/1000000)  + 0.07*math.sin(4*math.pi*f*t/1000000)
    odrv0.axis1.controller.input_pos = 0.1*math.sin(2*math.pi*f*t/1000000)  + 0.07*math.sin(4*math.pi*f*t/1000000)
odrv0.axis0.requested_state = AXIS_STATE_IDLE
odrv0.axis1.requested_state = AXIS_STATE_IDLE





